package nc.pubimpl.so.m30.pfxx;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.taskmanager.SynTaskTree;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillConcurrentTool;
import nc.impl.pubapp.pattern.rule.IRule;
import nc.impl.so.m30.action.main.InsertSaleOrderAction;
import nc.impl.so.m30.action.main.UpdateSaleOrderAction;
import nc.itf.uap.pf.IPFBusiAction;
import nc.pubimpl.so.pfxx.AbstractSOPfxxPlugin;
import nc.pubimpl.so.pfxx.check.BillFreeStatusCheckRule;
import nc.pubimpl.so.pfxx.check.MnyTaxCheckRule;
import nc.pubimpl.so.pfxx.check.WriteBackInfoCheckRule;
import nc.pubitf.uapbd.CurrencyRateUtil;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.workflow.IPFActionName;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.so.m30.entity.SaleOrderBVO;
import nc.vo.so.m30.entity.SaleOrderHVO;
import nc.vo.so.m30.entity.SaleOrderVO;
import nc.vo.wfengine.pub.WFTask;

public class M30PfxxPlugin extends AbstractSOPfxxPlugin {

  @Override
  public List<IRule<AggregatedValueObject>> getCheckers() {
    List<IRule<AggregatedValueObject>> rules =
        new ArrayList<IRule<AggregatedValueObject>>();
    // ״̬飬̬Ե
    rules.add(new BillFreeStatusCheckRule());
    // ˰ϼ=˰+˰ң
//    rules.add(new MnyTaxCheckRule(SaleOrderBVO.NTAX, SaleOrderBVO.NMNY,
//        SaleOrderBVO.NTAXMNY));
    // ۼֶ
    rules.add(new WriteBackInfoCheckRule(new String[] {
      SaleOrderBVO.NTOTALSENDNUM,// ۼƷ
      SaleOrderBVO.NTOTALINVOICENUM,// ۼƿƱ
      SaleOrderBVO.NTOTALOUTNUM,// ۼƳ
      SaleOrderBVO.NTOTALNOTOUTNUM,// ۼӦδ
      SaleOrderBVO.NTOTALSIGNNUM,// ۼǩ
      SaleOrderBVO.NTRANSLOSSNUM,// ۼ;
      SaleOrderBVO.NTOTALRUSHNUM,// ۼƳԳ
      SaleOrderBVO.NTOTALESTARNUM,// ۼݹӦ
      SaleOrderBVO.NTOTALARNUM,// ۼȷӦ
      SaleOrderBVO.NTOTALCOSTNUM,// ۼƳɱ
      SaleOrderBVO.NTOTALESTARMNY,// ۼݹӦս
      SaleOrderBVO.NTOTALARMNY,// ۼȷӦս
      SaleOrderBVO.NTOTALPAYMNY,// ۼտ
      SaleOrderBVO.NORIGSUBMNY,// ۼƳֽ
      SaleOrderBVO.NARRANGESCORNUM,// ۼưίⶩ
      SaleOrderBVO.NARRANGEPOAPPNUM,// ۼư빺
      SaleOrderBVO.NARRANGETOORNUM,// ۼưŵ
      SaleOrderBVO.NARRANGETOAPPNUM,// ۼưŵ
      SaleOrderBVO.NARRANGEMONUM,// ۼư
      SaleOrderBVO.NARRANGEPONUM,// ۼưŲɹ
      SaleOrderBVO.NTOTALPLONUM,// ۼɼƻ
      SaleOrderBVO.NTOTALRETURNNUM,// ۼ˻
      SaleOrderBVO.NTOTALTRADENUM
    // ۼƷƷ
        }));
    return rules;
  }

  @Override
  protected AggregatedValueObject insert(AggregatedValueObject vo) {

    SaleOrderVO[] insertvo = new SaleOrderVO[] {
      (SaleOrderVO) vo
    };

	/*ֻ */
	
	 /**
     * ԴĿıѯָڵĻ
     * 
     * @param src_currency_pk
     *            Դ
     * @param dest_currency_pk
     *            ĿıֵΪnullʱΪĬĿı
     * @param date
     * @return
     * @throws BusinessException
     */
	

    SaleOrderHVO headvo=(SaleOrderHVO) vo.getParentVO();
 //    if( headvo.getNexchangerate().compareTo(UFDouble.ONE_DBL)!=0){
 		String corigcurrencyid= headvo.getCorigcurrencyid();
 		CurrencyRateUtil currRateUtil = CurrencyRateUtil
 				.getInstanceByOrg(headvo.getPk_org());
 		try {
 			SaleOrderBVO[]  bodyvos= (SaleOrderBVO[]) vo.getChildrenVO();
 			for(SaleOrderBVO bodyvo:bodyvos){
 				String ccurrencyid= bodyvo.getCcurrencyid();
 				
 				if(corigcurrencyid.equals(ccurrencyid)){
 					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
 					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
 					UFDouble norigmny = bodyvo.getNorigmny();//˰
 					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
 					bodyvo.setNcaltaxmny(norigtaxmny);//˰
 					bodyvo.setNqttaxprice(nqtorigtaxprice);//Һ˰
 					bodyvo.setNqtprice(nqtorigprice);//˰
 					bodyvo.setNqttaxnetprice(nqtorigtaxprice);//Һ˰
 					bodyvo.setNorigtaxnetprice(nqtorigtaxprice);//˰
					bodyvo.setNorignetprice(nqtorigprice);//˰
 					bodyvo.setNqtnetprice(nqtorigprice);//˰
 					bodyvo.setNtaxprice(nqtorigtaxprice);//Һ˰
 					bodyvo.setNpiece(nqtorigprice);//˰
 					bodyvo.setNtaxnetprice(nqtorigtaxprice);//Һ˰
 					bodyvo.setNnetprice(nqtorigprice);//˰
 					bodyvo.setNmny(norigmny);//˰
 					bodyvo.setNtaxmny(norigtaxmny);//Ҽ˰ϼ
 					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice);//˰
					bodyvo.setNqtorignetprice(nqtorigprice);//˰
 					continue;
 				}
 				
 				
 				UFDouble foreignrate = currRateUtil.getRate(corigcurrencyid,/*ԭ*/
 	 					ccurrencyid/**/, headvo.getDbilldate());//
 				bodyvo.setNexchangerate(foreignrate);
 				//norigprice ԭ˰
 				UFDouble norigprice=bodyvo.getNorigtaxprice();//ԭҺ˰
 				UFDouble foreignAmount=	currRateUtil.getAmountByOpp(corigcurrencyid,
 						ccurrencyid, norigprice, foreignrate, headvo.getDbilldate());
 				bodyvo.setNtaxprice(foreignAmount);//Һ˰
 				
 				UFDouble ngprice=currRateUtil.getAmountByOpp(corigcurrencyid,
 						ccurrencyid, bodyvo.getNorigprice()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
 				
 				bodyvo.setNprice(ngprice); // ˰
 				
 				bodyvo.setNqtprice(ngprice); //۱˰
 				
 				bodyvo.setNqttaxprice(foreignAmount);//۱Һ˰
 				
 				
 				UFDouble nmny=currRateUtil.getAmountByOpp(corigcurrencyid,
 						ccurrencyid, bodyvo.getNorigmny()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
 				
 				bodyvo.setNmny(nmny);//˰  
 				
 				UFDouble ntaxmny=currRateUtil.getAmountByOpp(corigcurrencyid,
 						ccurrencyid, bodyvo.getNorigtaxmny()/*ԭҼ˰ϼ*/, foreignrate, headvo.getDbilldate());
 				
 				bodyvo.setNtaxmny(ntaxmny);//ntaxmny Ҽ˰ϼ
 				
 				bodyvo.setNcaltaxmny(nmny);//˰
 				bodyvo.setNqtnetprice(ngprice);//˰
 				bodyvo.setNnetprice(ngprice);//˰
 				
 				bodyvo.setNqttaxnetprice(foreignAmount);//Һ˰
 				bodyvo.setNorigtaxnetprice(foreignAmount);//˰
				bodyvo.setNorignetprice(ngprice);//˰
 				bodyvo.setNtaxnetprice(foreignAmount);//Һ˰
 				bodyvo.setNtax(ntaxmny.sub(nmny));//˰=˰ϼ-˰
 				bodyvo.setNqtorigtaxnetprc(foreignAmount);//˰
				bodyvo.setNqtorignetprice(ngprice);//˰
 			}
 			
 		} catch (BusinessException e1) {
 			 ExceptionUtils.wrappException(e1);
              return null;
 		}
	
	  InsertSaleOrderAction insertact = new InsertSaleOrderAction();
	  InvocationInfoProxy.getInstance().setUserId(insertvo[0].getParentVO().getBillmaker());
	    SaleOrderVO[] retvos = insertact.insert(insertvo);
	    if (null == retvos || retvos.length == 0) {
	      return null;
	    }
	    
	    
    
    //add by ZTH Ź ۶ͨ  
    
	String pk_org = retvos[0].getParentVO().getPk_org();
	//0001V510000000002GEH   Ż				
	if(pk_org != null && (pk_org.equals("0001V510000000002GDX"))){
	 IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
	 InvocationInfoProxy.getInstance().setUserId(retvos[0].getParentVO().getApprover());
	    try {
	    	service.processAction(IPFActionName.APPROVE,
			     "30", null, retvos[0], null, null);
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			ExceptionUtils.wrappBusinessException(e.getMessage());
		    return null;
		}
	}	
    
    

  
    
    return retvos[0];
  }

  @Override
  protected AggregatedValueObject update(AggregatedValueObject vo, String vopk) {

    SaleOrderVO[] updatevo = new SaleOrderVO[] {
      (SaleOrderVO) vo
    };
    BillQuery<SaleOrderVO> billquery =
        new BillQuery<SaleOrderVO>(SaleOrderVO.class);
    SaleOrderVO[] origvos = billquery.query(new String[] {
      vopk
    });
    BillConcurrentTool tool = new BillConcurrentTool();
    tool.lockBill(origvos);
    UpdateSaleOrderAction insertact = new UpdateSaleOrderAction();
    SaleOrderVO[] retvos = insertact.update(updatevo, origvos);
    if (null == retvos || retvos.length == 0) {
      return null;
    }
    return retvos[0];
  }

}
